### Name: and.globalSeg
### Title: Intersection of global segments
### Aliases: and.globalSeg &.globalSeg
### Keywords: utilities

### ** Examples

a = list(
    matrix( c( 1, 15, 17,  5, 45, 38),ncol=2),
    matrix( c( 100 , 120),ncol=2),
    matrix( c( 130, 135, 140, 145),ncol=2),
    matrix( c( 142 , 160),ncol=2))

b = list(
    matrix( c(15, 28, 18, 45),ncol=2),
    matrix( c(1, 15, 25, 10, 20, 40),ncol=2),
    matrix( c(17, 35, 23, 38),ncol=2),
    matrix( c(100, 110, 105, 120),ncol=2))

a = as.globalSeg(a)
b = as.globalSeg(b)


c = and(a,b,byrows=TRUE)
par(mfrow=c(5,1))
plot(a,xlim=c(1,160),main="A")
plot(b,xlim=c(1,160),main="B")
plot(a&b,xlim=c(1,160),main="A&B")
plot(c,xlim=c(1,160),main="A&B, byrow=T")
plot(and(a),xlim=c(1,160),main="and(A)")

## Show result
a&b
c
and(a)



